﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using System.IO;

namespace App.Engine {
    public class XmlSerializer<T> {

        public void Serialize(string filePath, T data) {
            var ser = new XmlSerializer(typeof(T));
            using (var fs = new FileStream(filePath, FileMode.CreateNew)) {
                ser.Serialize(fs, data);
            }
        }

        public T Deserialize(string filePath) {
            if (!File.Exists(filePath))
                return default(T);
            var ser = new XmlSerializer(typeof(T));
            using (var fs = new FileStream(filePath, FileMode.Open)) {
                return (T)ser.Deserialize(fs);
            }
        }
    }
}
