﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace App.Server.Initialization {
    public enum ApplicationMode {
        WindowsService,
        ConsoleHostService,
    }
    internal class ApplicationModeProvider {
        
        private Dictionary<string, ApplicationMode> _applicationsModesMap;
        private ApplicationMode _defaultApplicationMode = ApplicationMode.ConsoleHostService;

        public ApplicationMode ConfigApplicationMode {
            get {
                var configApplicationMode = ConfigurationManager.AppSettings["ApplicationMode"];
                if (_applicationsModesMap.ContainsKey(configApplicationMode))
                    return _applicationsModesMap[configApplicationMode];
                else
                    return _defaultApplicationMode;
            }
        }

        public ApplicationModeProvider() {
            _applicationsModesMap = new Dictionary<string, ApplicationMode>();
            InitializeMap();
        }

        private void InitializeMap() {
            _applicationsModesMap.Add("ConsoleHostServices", ApplicationMode.ConsoleHostService);
            _applicationsModesMap.Add("WindowsServices", ApplicationMode.WindowsService);
        }
    }
}
