﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Castle.Windsor;
using Castle.MicroKernel.Registration;
using App.Server.Services;
using App.Server.Services.Core;

namespace App.Server.Initialization {
    public class ContainerInstaller : IWindsorInstaller{

        public void Install(IWindsorContainer container, Castle.MicroKernel.SubSystems.Configuration.IConfigurationStore store) {
            container.Register(
                Component.For<IApplicationManagementService>().ImplementedBy<ApplicationManagementService>(),
                Component.For<IWcfServiceProvider>().ImplementedBy<WcfServiceProvider>(),
                Component.For<IHostingServices>().ImplementedBy<HostingServices>(),
                Component.For<WindowsService>().ImplementedBy<WindowsService>());
        }
    }
}
