﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace App.Server.Services.Core {
    public interface IHostingServices {
        void Host();
    }
    /// <summary>
    /// Host services retreive from WcfServiceProviders
    /// </summary>
    public class HostingServices : IHostingServices{
        private readonly IWcfServiceProvider _wcfServiceProvider;

        public HostingServices(IWcfServiceProvider wcfServiceProvider) {
            _wcfServiceProvider = wcfServiceProvider;
        }

        public void Host() {
            var applicationManagementServiceUri = ConfigurationManager.AppSettings["ApplicationManagementServiceUri"];
            _wcfServiceProvider.HostService<IApplicationManagementService, ApplicationManagementService>(applicationManagementServiceUri);
        }
    }
}
