﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using log4net;
using System.Diagnostics;

namespace Sandpit {
    /// <summary>
    /// Performance test shows that this solution is 
    /// </summary>
    public class DelegateStaticLogger {
        public class Storage {
            public Dictionary<string, ILog> Logs { get; set; }

            public Storage() {
                Logs = new Dictionary<string, ILog>();
            }

            public ILog GetLog(string loggerName) {
                if (_logStorage.Logs.ContainsKey(loggerName))
                    return _logStorage.Logs[loggerName];
                else {
                    var log = LogManager.GetLogger(loggerName);
                    _logStorage.Logs.Add(loggerName, log);
                    return log;
                }
            }
        }

        private static Storage _logStorage = new Storage();

        private static string GetKey() {
            StackTrace trace = new StackTrace();
            var frame = trace.GetFrame(1);
            var method = frame.GetMethod();
            return method.DeclaringType.FullName + "(" + method.Name + ")";
        }

        public static void InfoCache(string message) {

            var loggerName = GetKey();
            var logger = _logStorage.GetLog(loggerName);

            logger.Info(message);
        }

        public static void InfoNoCache(string message) {

            var loggerName = GetKey();
            var logger = LogManager.GetLogger(loggerName);

            logger.Info(message);
        }
    }
}
